diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 5976a3e3a..04ba1e808 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -187,530 +179,447 @@ public class Block
         return this;
     }
 
-    public Block withLitInteriorSurface(boolean isLit)
+    public Block<T> withLitInteriorSurface(boolean isLit)
     {
         isLitInteriorSurface = isLit;
         return this;
     }
-    public Block withSetUnbreakable()
+    public Block<T> withSetUnbreakable()
     {
         withHardness(-1F);
         return this;
     }
-    public Block setBlockItem(@NotNull Supplier<Item> itemSupplier){
+    public Block<T> setBlockItem(@NotNull Supplier<Item> itemSupplier){
         this.blockItemSupplier = itemSupplier;
         return this;
     }
 
-    public Block setBlockItem(@NotNull Function<Block, Item> itemSupplier){
+    public Block<T> setBlockItem(@NotNull Function<Block<T>, Item> itemSupplier){
         this.blockItemSupplier = () -> itemSupplier.apply(this);
         return this;
     }
-    public Block withOverrideColor(MaterialColor color){
+    public Block<T> withOverrideColor(MaterialColor color){
         this.overrideColor = color;
         return this;
     }
 
-    public Block setStatParent(@NotNull Supplier<@NotNull IItemConvertible> icon){
+    public Block<T> setStatParent(@NotNull Supplier<@NotNull IItemConvertible> icon){
         this.statParent = icon;
         return this;
     }
 
-    public float getHardness()
+    public Block<T> withDisabledStats()
     {
-        return blockHardness;
+        enableStats = false;
+        return this;
     }
 
-    /**
-     * Make sure if this gets overridden in a block that {@link Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
-     */
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public Block<T> setTicking(boolean tick)
     {
-        return getBreakResult(world, dropCause, meta, tileEntity);
+        this.shouldTick = tick;
+        return this;
     }
 
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
+    public BlockSound getSound()
     {
-        if (dropCause != EnumDropCause.IMPROPER_TOOL)
-        {
-            return new ItemStack[] { new ItemStack(this) };
-        }
-        else return null;
+        return blockSound;
     }
 
-    public Block setTicking(boolean tick)
-    {
-        Blocks.shouldTick[id] = tick;
-        return this;
+    public Material getMaterial() {
+        return logic.getMaterial();
     }
 
-    protected void setBlockBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
+    public float getHardness()
     {
-        bounds.set(minX, minY, minZ, maxX, maxY, maxZ);
+        return blockHardness;
     }
 
-    public AABB getBounds() {
-        return bounds.copy();
+    public boolean getEnableStats()
+    {
+        return enableStats && getHardness() >= 0F;
     }
 
-    public AABB getBoundsRaw() {
-        return bounds;
+    @Nullable
+    public Stat getStat(String statID) {
+        return asItem().getStat(statID);
     }
 
-	public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
-	}
-
-	public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getLightmapCoord(x, y, z, Blocks.lightEmission[id]);
-	}
-
-	/**
-	 * Used when fullbright or lightmap is active
-	 */
-	public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
-		return isSolidRender() ? 1.0f : 0.0f;
-	}
-
-    public boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return blockAccess.getBlockMaterial(x, y, z).isSolid();
+    public MaterialColor getMaterialColor(){
+        if (overrideColor != null) return overrideColor;
+        return getMaterialColor();
     }
 
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
+    @Override
+    public int id() {
+        return id;
     }
 
-    public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
-    {
-        return null;
+    public @NotNull String getKey() {
+        return key;
     }
 
-    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
-    {
-        addIntersectingBoundingBox(aabb, getCollisionBoundingBoxFromPool(world, x, y, z), aabbList);
+    public @NotNull NamespaceID namespaceId() {
+        return namespaceID;
     }
 
-    protected void addIntersectingBoundingBox(AABB sourceAABB, AABB aabbToAdd, ArrayList<AABB> aabbList) {
-        if(aabbToAdd != null && sourceAABB.intersects(aabbToAdd))
-        {
-            aabbList.add(aabbToAdd);
-        }
+    public void init() {
+        this.logic = logicSupplier.get(this);
     }
 
-    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z)
-    {
-        return true;
-    }
 
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
-    }
-    public MaterialColor getMaterialColor(){
-        if (overrideColor != null) return overrideColor;
-        return blockMaterial.color;
+    @Override
+    public boolean isIn(Tag<Block<?>> tag) {
+        return tag.appliesTo(this);
     }
 
-    public boolean isSolidRender()
-    {
-        return true;
+    @Override
+    public Item asItem() {
+        return Item.itemsList[id];
     }
 
-    public boolean blocksLight()
-    {
-        return false;
+    @Override
+    public ItemStack getDefaultStack() {
+        return new ItemStack(this);
     }
 
-    public boolean canCollideCheck(int meta, boolean shouldCollideWithFluids)
+    public static boolean isBuried (World world, int x, int y, int z)
     {
-        return isCollidable();
+        boolean buried = true;
+        if(Blocks.lightBlock[world.getBlockId(x + 1, y, z)] <= 2)
+            buried = false;
+        if(Blocks.lightBlock[world.getBlockId(x - 1, y, z)] <= 2)
+            buried = false;
+        if(Blocks.lightBlock[world.getBlockId(x, y, z + 1)] <= 2)
+            buried = false;
+        if(Blocks.lightBlock[world.getBlockId(x, y, z - 1)] <= 2)
+            buried = false;
+        if(Blocks.lightBlock[world.getBlockId(x, y + 1, z)] <= 2)
+            buried = false;
+        if(Blocks.lightBlock[world.getBlockId(x, y - 1, z)] <= 2)
+            buried = false;
+        return buried;
     }
 
-    public boolean isCollidable()
+    public static boolean getIsLitInteriorSurface (World world, int x, int y, int z)
     {
-        return true;
+        int l = world.getBlockId(x, y, z);
+        return l != 0 && Blocks.blocksList[l] != null && Blocks.blocksList[l].isLitInteriorSurface;
     }
 
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    @SafeVarargs
+    public final Block<T> withTags(Tag<Block<?>>... tags)
     {
-    }
+        for (Tag<Block<?>> tag : tags)
+        {
+            tag.tag(this);
+        }
 
-    public void animationTick(World world, int x, int y, int z, Random rand)
-    {
+        return this;
     }
 
-    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    public boolean hasTag(Tag<Block<?>> tag)
     {
+        return tag.appliesTo(this);
     }
 
-    public int tickDelay()
-    {
-        return 10;
+    @Override
+    public boolean isCubeShaped() {
+        return logic.isCubeShaped();
     }
 
-    public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
+    @Override
+    public boolean canPlaceOnSurface() {
+        return logic.canPlaceOnSurface();
     }
 
-
-    /**
-     * Always called when a block is removed by setBlock
-     */
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
+    @Override
+    public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z) {
+        return logic.canPlaceOnSurfaceOnCondition(world, x, y, z);
     }
 
-    /**
-     * Called when a block has been broken by a player, after {@link Block#onBlockRemoved(World, int, int, int, int)}
-     */
-    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+    @Override
+    public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z) {
+        return logic.renderAsNormalBlockOnCondition(world, x, y, z);
+    }
 
+    @Override
+    public boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z) {
+        return logic.canPlaceOnSurfaceOfBlock(world, x, y, z);
     }
 
-    public float blockStrength(World world, int x, int y, int z, Side side, Player player)
-    {
-        if(blockHardness < 0.0F)
-        {
-            return 0.0F;
-        }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+        return logic.getBreakResult(world, dropCause, x, y, z, meta, tileEntity);
+    }
 
-        if (!player.canHarvestBlock(this))
-        {
-            return 1.0F / blockHardness / 100F;
-        }
-        else
-        {
-            return player.getCurrentPlayerStrVsBlock(this) / blockHardness / 30F;
-        }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        return logic.getBreakResult(world, dropCause, meta, tileEntity);
     }
 
-    public boolean getImmovable()
-    {
-        return this.immovable;
+    @Override
+    public AABB getBounds() {
+        return logic.getBounds();
     }
 
-    public float getBlastResistance(Entity entity)
-    {
-        return blastResistance / 5F;
+    @Override
+    public AABB getBoundsRaw() {
+        return logic.getBoundsRaw();
     }
 
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end, boolean useSelectorBoxes)
-    {
-        AABB bounds = useSelectorBoxes ? getSelectedBoundingBoxFromPool(world, x, y, z).move(-x, -y, -z) : getBlockBoundsFromState(world, x, y, z);
-        start = start.add(-x, -y, -z);
-        end = end.add(-x, -y, -z);
-		Vec3 minVX = start.clipX(end, bounds.minX);
-		Vec3 maxVX = start.clipX(end, bounds.maxX);
-		Vec3 minVY = start.clipY(end, bounds.minY);
-		Vec3 maxVY = start.clipY(end, bounds.maxY);
-		Vec3 minVZ = start.clipZ(end, bounds.minZ);
-		Vec3 maxVZ = start.clipZ(end, bounds.maxZ);
-
-		if(!isVecInsideYZBounds(bounds,minVX)) minVX = null;
-		if(!isVecInsideYZBounds(bounds,maxVX)) maxVX = null;
-		if(!isVecInsideXZBounds(bounds,minVY)) minVY = null;
-		if(!isVecInsideXZBounds(bounds,maxVY)) maxVY = null;
-		if(!isVecInsideXYBounds(bounds,minVZ)) minVZ = null;
-		if(!isVecInsideXYBounds(bounds,maxVZ)) maxVZ = null;
-
-		Vec3 vec38 = null;
-		if(minVX != null && (vec38 == null || start.distanceToSquared(minVX) < start.distanceToSquared(vec38))) vec38 = minVX;
-		if(maxVX != null && (vec38 == null || start.distanceToSquared(maxVX) < start.distanceToSquared(vec38))) vec38 = maxVX;
-		if(minVY != null && (vec38 == null || start.distanceToSquared(minVY) < start.distanceToSquared(vec38))) vec38 = minVY;
-		if(maxVY != null && (vec38 == null || start.distanceToSquared(maxVY) < start.distanceToSquared(vec38))) vec38 = maxVY;
-		if(minVZ != null && (vec38 == null || start.distanceToSquared(minVZ) < start.distanceToSquared(vec38))) vec38 = minVZ;
-		if(maxVZ != null && (vec38 == null || start.distanceToSquared(maxVZ) < start.distanceToSquared(vec38))) vec38 = maxVZ;
-
-		if(vec38 == null) return null;
-		Side side = Side.NONE;
-		if(vec38 == minVX) side = Side.WEST;
-		if(vec38 == maxVX) side = Side.EAST;
-		if(vec38 == minVY) side = Side.BOTTOM;
-		if(vec38 == maxVY) side = Side.TOP;
-		if(vec38 == minVZ) side = Side.NORTH;
-		if(vec38 == maxVZ) side = Side.SOUTH;
-
-        return new HitResult(x, y, z, side, vec38.add(x, y, z));
-    }
-
-    private boolean isVecInsideYZBounds(AABB bounds, @Nullable Vec3 vec3)
-    {
-        if(vec3 == null) {
-            return false;
-        }
-        return vec3.y >= bounds.minY && vec3.y <= bounds.maxY && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
+    @Override
+    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z) {
+        return logic.getBlockBrightness(blockAccess, x, y, z);
     }
 
-    private boolean isVecInsideXZBounds(AABB bounds, @Nullable Vec3 vec3)
-    {
-        if(vec3 == null) {
-            return false;
-        }
-        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
+    @Override
+    public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
+        return logic.getLightmapCoord(blockAccess, x, y, z);
     }
 
-    private boolean isVecInsideXYBounds(AABB bounds, @Nullable Vec3 vec3)
-    {
-        if(vec3 == null) {
-            return false;
-        }
-        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.y >= bounds.minY && vec3.y <= bounds.maxY;
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+        return logic.getAmbientOcclusionStrength(blockAccess, x, y, z);
     }
 
-    public void onBlockDestroyedByExplosion(World world, int x, int y, int z)
-    {
+    @Override
+    public boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side) {
+        return logic.getIsBlockSolid(blockAccess, x, y, z, side);
     }
 
-    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side)
-    {
-        return canPlaceBlockAt(world, x, y, z);
+    @Override
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+        return logic.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
 
-    public boolean canPlaceBlockAt(World world, int x, int y, int z)
-    {
-    	return world.canPlaceInsideBlock(x, y, z);
+    @Override
+    public BoundingVolume getBoundingVolume(World world, int x, int y, int z) {
+        return logic.getBoundingVolume(world, x, y, z);
     }
 
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
-    {
-        return false;
+    @Override
+    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList) {
+        logic.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
     }
 
-    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
+    @Override
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
+        return logic.collidesWithEntity(entity, world, x, y, z);
     }
 
-    public void onEntityWalking(World world, int x, int y, int z, Entity entity)
-    {
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+        return logic.getCollisionBoundingBoxFromPool(world, x, y, z);
     }
 
-    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
-    {
+    @Override
+    public boolean isSolidRender() {
+        return logic.isSolidRender();
     }
 
-    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
-    {
+    @Override
+    public boolean blocksLight() {
+        return logic.blocksLight();
     }
-    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
-    {
-        return getBounds();
+
+    @Override
+    public boolean canCollideCheck(int meta, boolean shouldCollideWithFluids) {
+        return logic.canCollideCheck(meta, shouldCollideWithFluids);
     }
 
-    /**
-     * Gets the redstone signal output by the block itself, i.e. the power it will provide to any immediately adjacent redstone components.
-     */
-    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
-    {
-        return false;
+    @Override
+    public boolean isCollidable() {
+        return logic.isCollidable();
     }
 
-    public boolean isSignalSource()
-    {
-        return false;
+    @Override
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+        logic.updateTick(world, x, y, z, rand);
     }
 
-    public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
-    {
+    @Override
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+        logic.animationTick(world, x, y, z, rand);
     }
 
-    /**
-     * Gets the redstone signal pushed into adjacent solid blocks. Any block experiencing *direct* signal will power itself and all adjacent blocks.
-     */
-    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
-    {
-        return false;
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        logic.onNeighborBlockChange(world, x, y, z, blockId);
     }
 
-    public void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity)
-    {
-    	player.addStat(getStat(StatList.STAT_MINED), 1);
+    @Override
+    public int tickDelay() {
+        return logic.tickDelay();
+    }
 
-		ItemStack heldItemStack = player.inventory.getCurrentItem();
-		Item heldItem = heldItemStack != null ? Item.itemsList[heldItemStack.itemID] : null;
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+        if (isEntityTile && !disableNormalEntityLogic && entitySupplier != null) {
+            world.setBlockTileEntity(x, y, z, entitySupplier.get());
+        }
+        logic.onBlockPlacedByWorld(world, x, y, z);
+    }
 
-        if (heldItem != null)
-        {
-            if (heldItem.isSilkTouch() && player.canHarvestBlock(this))
-            {
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity, player);
-                return;
-            }
-            else if (heldItem instanceof ItemToolShears && (this.hasTag(BlockTags.SHEARS_DO_SILK_TOUCH) || this.hasTag(BlockTags.MINEABLE_BY_SHEARS)))
-            {
-                ItemToolShears heldShears = (ItemToolShears) heldItem;
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity, player);
-                heldShears.onBlockSheared(player, heldItemStack);
-                return;
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        logic.onBlockRemoved(world, x, y, z, data);
+        if (isEntityTile && !disableNormalEntityLogic) {
+            if (!world.isClientSide) {
+                TileEntity tileEntity = world.getBlockEntity(x, y, z);
+                if(tileEntity != null) {
+                    tileEntity.dropContents(world, x, y, z);
+                }
             }
+            world.removeBlockTileEntity(x, y, z);
         }
+    }
 
-        if (player.canHarvestBlock(this))
-        {
-            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, tileEntity, player);
-        }
-        else
-        {
-            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, tileEntity, player);
-        }
-	}
+    @Override
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+        logic.onBlockDestroyedByPlayer(world, x, y, z, side, meta, player, item);
+    }
 
-    @Nullable
-    public Stat getStat(String statID) {
-        return asItem().getStat(statID);
+    @Override
+    public float blockStrength(World world, int x, int y, int z, Side side, Player player) {
+        return logic.blockStrength(world, x, y, z, side, player);
     }
 
-	public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player) {
-		if(world.isClientSide)
-			return;
+    @Override
+    public boolean getImmovable() {
+        return logic.getImmovable();
+    }
 
-		ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, tileEntity);
-        if (drops == null) {
-            return;
-        }
-        for (int j = 0, dropsLength = drops.length; j < dropsLength; j++) {
-            ItemStack drop = drops[j];
-            if (drop == null) {
-                continue;
-            }
-            if (hasTag(BlockTags.INSTANT_PICKUP) && player != null) {
-                player.inventory.insertItem(drop, true);
-                if (drop.stackSize <= 0) {
-                    continue;
-                }
-            }
-            if (EntityItem.enableItemClumping) {
-                world.dropItem(x, y, z, drop.copy());
-            } else {
-                for (int i = 0; i < drop.stackSize; i++) {
-                    ItemStack drop1 = drop.copy();
-                    drop1.stackSize = 1;
-                    world.dropItem(x, y, z, drop1);
-                }
-            }
-        }
+    @Override
+    public float getBlastResistance(Entity entity) {
+        return logic.getBlastResistance(entity);
     }
 
-    public ISupport getSupport(World world, int x, int y, int z, Side side) {
-        return FullSupport.INSTANCE;
+    @Override
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end, boolean useSelectorBoxes) {
+        return logic.collisionRayTrace(world, x, y, z, start, end, useSelectorBoxes);
     }
 
-    public boolean canBlockStay(World world, int x, int y, int z)
-    {
-        return true;
+    @Override
+    public void onBlockDestroyedByExplosion(World world, int x, int y, int z) {
+        logic.onBlockDestroyedByExplosion(world, x, y, z);
     }
 
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
-        onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
+    @Override
+    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
+        return logic.canPlaceBlockOnSide(world, x, y, z, side);
     }
 
-    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        return logic.canPlaceBlockAt(world, x, y, z);
+    }
 
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        return logic.onBlockRightClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
-    public String getKey()
-    {
-        return key;
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
+        logic.onActivatorInteract(world, x, y, z, activator, direction);
     }
 
-    public String getLanguageKey(int meta)
-    {
-        return getKey();
+    @Override
+    public void onEntityWalking(World world, int x, int y, int z, Entity entity) {
+        logic.onEntityWalking(world, x, y, z, entity);
     }
 
-    public void triggerEvent(World world, int x, int y, int z, int index, int data)
-    {
+    @Override
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        logic.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
+    }
 
+    @Override
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity) {
+        logic.handleEntityInside(world, x, y, z, entity, entityVelocity);
     }
 
-    public boolean getEnableStats()
-    {
-        return enableStats && getHardness() >= 0F;
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
+        return logic.getBlockBoundsFromState(world, x, y, z);
     }
 
-    public Block withDisabledStats()
-    {
-        enableStats = false;
-        return this;
+    @Override
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
+        return logic.getSignal(worldSource, x, y, z, side);
     }
 
-    public int getPistonPushReaction(World world, int x, int y, int z)
-    {
-        return blockMaterial.getPushReaction();
+    @Override
+    public boolean isSignalSource() {
+        return logic.isSignalSource();
     }
-    
-    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
-    {
-    	return 0;
+
+    @Override
+    public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity) {
+        logic.onEntityCollidedWithBlock(world, x, y, z, entity);
     }
 
-    public static boolean isBuried (World world, int x, int y, int z)
-    {
-        boolean buried = true;
-        if(Blocks.lightBlock[world.getBlockId(x + 1, y, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x - 1, y, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y, z + 1)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y, z - 1)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y + 1, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y - 1, z)] <= 2)
-            buried = false;
-        return buried;
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        return logic.getDirectSignal(world, x, y, z, side);
     }
 
-    public static boolean getIsLitInteriorSurface (World world, int x, int y, int z)
-    {
-        int l = world.getBlockId(x, y, z);
-        return l != 0 && Blocks.blocksList[l] != null && Blocks.blocksList[l].isLitInteriorSurface;
+    @Override
+    public void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity) {
+        logic.harvestBlock(world, player, x, y, z, meta, tileEntity);
     }
 
-    @SafeVarargs
-    public final Block withTags(Tag<Block>... tags)
-    {
-        for (Tag<Block> tag : tags)
-        {
-            tag.tag(this);
-        }
+    @Override
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player) {
+        logic.dropBlockWithCause(world, cause, x, y, z, meta, tileEntity, player);
+    }
 
-        return this;
+    @Override
+    public ISupport getSupport(World world, int x, int y, int z, Side side) {
+        return logic.getSupport(world, x, y, z, side);
     }
 
-    public boolean hasTag(Tag<Block> tag)
-    {
-        return tag.appliesTo(this);
+    @Override
+    public boolean canBlockStay(World world, int x, int y, int z) {
+        return logic.canBlockStay(world, x, y, z);
     }
 
-    public static boolean hasTag(int id, Tag<Block> tag)
-    {
-        if (id < 0) return false;
-        Block block = Blocks.blocksList[id];
-        if (block == null) return false;
-        return block.hasTag(tag);
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        logic.onBlockPlacedByMob(world, x, y, z, side, mob, xPlaced, yPlaced);
     }
 
-    public boolean isClimbable(World world, int x, int y, int z) {
-    	return false;
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        logic.onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
     }
 
-    @NotNull
-    public Supplier<Item> blockItemSupplier = () -> new ItemBlock(this);
+    @Override
+    public String getLanguageKey(int meta) {
+        return logic.getLanguageKey(meta);
+    }
 
     @Override
-	public boolean isIn(Tag<Block> tag) {
-        return tag.appliesTo(this);
+    public void triggerEvent(World world, int x, int y, int z, int index, int data) {
+        logic.triggerEvent(world, x, y, z, index, data);
     }
 
     @Override
-    public Item asItem() {
-        return Item.itemsList[id];
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        return logic.getPistonPushReaction(world, x, y, z);
     }
 
     @Override
-    public ItemStack getDefaultStack() {
-        return new ItemStack(this);
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+        return logic.getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
+    }
+
+    @Override
+    public boolean isClimbable(World world, int x, int y, int z) {
+        return logic.isClimbable(world, x, y, z);
+    }
+
+    public static boolean hasLogicClass(@Nullable Block<?> block, Class<?> logicClass) {
+        return block != null && block.getLogic().getClass().isAssignableFrom(logicClass);
     }
 }
